Index: varia/src/main/org/jboss/jmx/adaptor/control/Server.java
===================================================================
--- varia/src/main/org/jboss/jmx/adaptor/control/Server.java	(revision 112986)
+++ varia/src/main/org/jboss/jmx/adaptor/control/Server.java	(working copy)
@@ -23,7 +23,6 @@
 
 import java.beans.IntrospectionException;
 import java.beans.PropertyEditor;
-import java.beans.PropertyEditorManager;
 import java.util.HashMap;
 import java.util.Iterator;
 import java.util.Set;
@@ -39,12 +38,13 @@
 import javax.management.ObjectName;
 import javax.management.ReflectionException;
 
+import org.jboss.common.beans.property.BeanUtils;
+import org.jboss.common.beans.property.finder.PropertyEditorFinder;
 import org.jboss.jmx.adaptor.model.DomainData;
 import org.jboss.jmx.adaptor.model.MBeanData;
 import org.jboss.logging.Logger;
 import org.jboss.mx.util.MBeanServerLocator;
 import org.jboss.util.Classes;
-import org.jboss.util.propertyeditor.PropertyEditors;
 
 /** Utility methods related to the MBeanServer interface
  *
@@ -160,7 +160,7 @@
       }
       PropertyEditor editor = null;
       if( typeClass != null )
-         editor = PropertyEditorManager.findEditor(typeClass);
+         editor = PropertyEditorFinder.getInstance().find(typeClass);
 
       return new AttrResultInfo(attrName, editor, value, throwable);
    }
@@ -187,7 +187,7 @@
          Attribute attr = null;
          try
          {
-            Object realValue = PropertyEditors.convertValue(value, attrType);
+            Object realValue = BeanUtils.convertValue(value, attrType);
             attr = new Attribute(attrName, realValue);
          }
          catch(ClassNotFoundException e)
@@ -236,7 +236,7 @@
          String arg = args[p];
          try
          {
-            Object argValue = PropertyEditors.convertValue(arg, argTypes[p]);
+            Object argValue = BeanUtils.convertValue(arg, argTypes[p]);
             typedArgs[p] = argValue;
          }
          catch(ClassNotFoundException e)
Index: varia/src/resources/jmx/html/inspectMBean.jsp
===================================================================
--- varia/src/resources/jmx/html/inspectMBean.jsp	(revision 112986)
+++ varia/src/resources/jmx/html/inspectMBean.jsp	(working copy)
@@ -9,7 +9,7 @@
    java.lang.reflect.Array,
    java.io.StringWriter,
    java.beans.PropertyEditor,
-   org.jboss.util.propertyeditor.PropertyEditors"
+   org.jboss.common.beans.property.BeanUtils"
 %>
 
 <%
@@ -237,7 +237,7 @@
         out.print("<input type='radio' name='"+attrName+"' value='True' "+trueChecked+"/>True");
         out.print("<input type='radio' name='"+attrName+"' value='False' "+falseChecked+"/>False");
 	// For wrappers, enable a 'null' selection
-	if ( attrType.equals( "java.lang.Boolean" ) && PropertyEditors.isNullHandlingEnabled() )
+	if ( attrType.equals( "java.lang.Boolean" ) && BeanUtils.isNullHandlingEnabled() )
         {
 		out.print("<input type='radio' name='"+attrName+"' value='' "+naChecked+"/>True");
 	}
Index: varia/src/resources/jmx/html/displayOpResult.jsp
===================================================================
--- varia/src/resources/jmx/html/displayOpResult.jsp	(revision 112986)
+++ varia/src/resources/jmx/html/displayOpResult.jsp	(working copy)
@@ -3,7 +3,7 @@
    import="java.net.*,
            java.io.*,
    		   java.beans.PropertyEditor,
-   		   org.jboss.util.propertyeditor.PropertyEditors"
+   		   org.jboss.common.beans.property.finder.PropertyEditorFinder"
 %>
 <%
 String hostname = "";
@@ -73,7 +73,7 @@
    {
       String opResultString = null;
 
-      PropertyEditor propertyEditor = PropertyEditors.findEditor(opResultInfo.result.getClass());
+      PropertyEditor propertyEditor = PropertyEditorFinder.getInstance().find(opResultInfo.result.getClass());
       if(propertyEditor != null)
       {
          propertyEditor.setValue(opResultInfo.result);
Index: j2se/.classpath
===================================================================
--- j2se/.classpath	(revision 112986)
+++ j2se/.classpath	(working copy)
@@ -10,6 +10,7 @@
 	<classpathentry exported="true" kind="lib" path="/thirdparty/dom4j/lib/dom4j.jar"/>
 	<classpathentry exported="true" kind="lib" path="/thirdparty/jboss/jboss-reflect/lib/jboss-reflect.jar" sourcepath="/thirdparty/jboss/jboss-reflect/lib/jboss-reflect-sources.jar"/>
 	<classpathentry exported="true" kind="lib" path="/thirdparty/jboss/integration/lib/jboss-integration.jar" sourcepath="/thirdparty/jboss/integration/lib/jboss-integration-sources.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/jboss/common-beans/lib/jboss-common-beans.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/junit/lib/junit.jar"/>
 	<classpathentry kind="output" path="output/eclipse-classes"/>
 </classpath>
Index: j2se/src/main/org/jboss/mx/util/MBeanInstaller.java
===================================================================
--- j2se/src/main/org/jboss/mx/util/MBeanInstaller.java	(revision 112986)
+++ j2se/src/main/org/jboss/mx/util/MBeanInstaller.java	(working copy)
@@ -22,7 +22,6 @@
 package org.jboss.mx.util;
 
 import java.beans.PropertyEditor;
-import java.beans.PropertyEditorManager;
 import java.io.InputStream;
 import java.util.Date;
 import java.util.HashMap;
@@ -37,6 +36,7 @@
 import javax.management.ObjectName;
 import javax.management.ReflectionException;
 
+import org.jboss.common.beans.property.finder.PropertyEditorFinder;
 import org.jboss.logging.Logger;
 import org.jboss.mx.loading.MBeanElement;
 import org.jboss.mx.server.ObjectInputStreamWithClassLoader;
@@ -110,19 +110,7 @@
     * Logger instance.
     */
    private static final Logger log = Logger.getLogger(MBeanInstaller.class);
-
-   /** Augment the PropertyEditorManager search path to incorporate the JBoss
-       specific editors. This simply references the PropertyEditors.class to
-       invoke its static initialization block.
-   */
-   static
-   {
-      Class c = org.jboss.util.propertyeditor.PropertyEditors.class;
-      if (c == null)
-         throw new UnreachableStatementException();
-   }
    
-   
    // Attributes ----------------------------------------------------
    
    /**
@@ -241,7 +229,7 @@
          try
          {
             Class typeClass = server.getClassLoaderRepository().loadClass(classes[i]);
-            PropertyEditor editor = PropertyEditorManager.findEditor(typeClass);
+            PropertyEditor editor = PropertyEditorFinder.getInstance().find(typeClass);
             if (editor == null)
                throw new IllegalArgumentException("No property editor for type=" + typeClass);
 
Index: j2se/src/main/org/jboss/mx/util/propertyeditor/ObjectNameEditor.java
===================================================================
--- j2se/src/main/org/jboss/mx/util/propertyeditor/ObjectNameEditor.java	(revision 112986)
+++ j2se/src/main/org/jboss/mx/util/propertyeditor/ObjectNameEditor.java	(working copy)
@@ -36,6 +36,7 @@
 public class ObjectNameEditor
    extends TextPropertyEditorSupport
 {
+    //TODO: push to beans
    /**
     * Returns a ObjectName for the input object converted to a string.
     *
Index: server/.classpath
===================================================================
--- server/.classpath	(revision 112986)
+++ server/.classpath	(working copy)
@@ -19,6 +19,7 @@
 	<classpathentry kind="lib" path="/thirdparty/jboss/jboss-jpa-deployers/lib/jboss-jpa-deployers.jar" sourcepath="/thirdparty/jboss/jboss-jpa-deployers/lib/jboss-jpa-deployers-sources.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/serialization/lib/jboss-serialization.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/web/lib/servlet-api.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/jboss/common-beans/lib/jboss-common-beans.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/microcontainer/lib/jboss-dependency.jar" sourcepath="/thirdparty/jboss/microcontainer/lib/jboss-dependency-sources.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/microcontainer/lib/jboss-kernel.jar" sourcepath="/thirdparty/jboss/microcontainer/lib/jboss-kernel-sources.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/jboss-bootstrap/lib/jboss-bootstrap.jar"/>
Index: server/src/main/org/jboss/ejb/plugins/EntityInstanceCache.java
===================================================================
--- server/src/main/org/jboss/ejb/plugins/EntityInstanceCache.java	(revision 112986)
+++ server/src/main/org/jboss/ejb/plugins/EntityInstanceCache.java	(working copy)
@@ -27,6 +27,7 @@
 import javax.ejb.TimerService;
 import javax.management.ObjectName;
 
+import org.jboss.common.beans.property.BeanUtils;
 import org.jboss.ejb.Container;
 import org.jboss.ejb.EntityContainer;
 import org.jboss.ejb.EnterpriseContext;
@@ -35,7 +36,6 @@
 import org.jboss.ejb.txtimer.EJBTimerService;
 import org.jboss.metadata.EntityMetaData;
 import org.jboss.metadata.ConfigurationMetaData;
-import org.jboss.util.propertyeditor.PropertyEditors;
 
 /**
  * Cache subclass for entity beans.
@@ -91,7 +91,7 @@
    {
       EntityMetaData metaData = (EntityMetaData) m_container.getBeanMetaData();
       String primKeyClass = metaData.getPrimaryKeyClass();
-      Object key = PropertyEditors.convertValue(id, primKeyClass);
+      Object key = BeanUtils.convertValue(id, primKeyClass);
       remove(key);
    }
 
Index: server/src/main/org/jboss/naming/JNDIBinding.java
===================================================================
--- server/src/main/org/jboss/naming/JNDIBinding.java	(revision 112986)
+++ server/src/main/org/jboss/naming/JNDIBinding.java	(working copy)
@@ -23,7 +23,8 @@
 
 import java.beans.PropertyEditor;
 
-import org.jboss.util.propertyeditor.PropertyEditors;
+import org.jboss.common.beans.property.BeanUtils;
+import org.jboss.common.beans.property.finder.PropertyEditorFinder;
 
 /**
  * A representation of a binding into JNDI.
@@ -143,7 +144,7 @@
          }
          else if( type != null )
          {
-            PropertyEditor pe = PropertyEditors.getEditor(type);
+            PropertyEditor pe = PropertyEditorFinder.getInstance().find(BeanUtils.findClass(type));
             pe.setAsText(text);
             value = pe.getValue();
          }
Index: main/.classpath
===================================================================
--- main/.classpath	(revision 112986)
+++ main/.classpath	(working copy)
@@ -4,5 +4,7 @@
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
 	<classpathentry exported="true" kind="lib" path="/thirdparty/gnu-getopt/lib/getopt.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/jboss-bootstrap/lib/jboss-bootstrap.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/jboss/common-beans/lib/jboss-common-beans.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/jboss/common-core/lib/jboss-common-core.jar"/>
 	<classpathentry kind="output" path="output/eclipse-classes"/>
 </classpath>
Index: main/src/main/org/jboss/Main.java
===================================================================
--- main/src/main/org/jboss/Main.java	(revision 112986)
+++ main/src/main/org/jboss/Main.java	(working copy)
@@ -61,8 +61,11 @@
  */
 public class Main
 {
-   /** EDU.oswego.cs.dl.util.concurrent */
-   private String concurrentLib = "concurrent.jar";
+    /** EDU.oswego.cs.dl.util.concurrent */
+    private String concurrentLib = "concurrent.jar";
+    
+    /** PEs and utils. */
+    private String commonBeansLIb = "jboss-common-beans.jar";
 
    /** A URL for obtaining microkernel patches */
    private URL bootURL;
@@ -197,6 +200,8 @@
 
       // jmx UnifiedLoaderRepository needs a concurrent class...
       loader.addLibrary(concurrentLib);
+      // PEs and utils are required at boot
+      loader.addLibrary(commonBeansLIb);
 
       // Add any extra libraries after the boot libs
       for (int i = 0; i < extraLibraries.size(); i++)
@@ -535,7 +540,6 @@
       if (System.getProperty("jboss.vfs.forceCopy") == null)
          System.setProperty("jboss.vfs.forceCopy", "true");
    }
-
    /**
     * This is where the magic begins.
     *
Index: testsuite/.classpath
===================================================================
--- testsuite/.classpath	(revision 112986)
+++ testsuite/.classpath	(working copy)
@@ -61,5 +61,6 @@
 	<classpathentry kind="lib" path="/thirdparty/jboss/jboss-ejb3-proxy-spi/lib/jboss-ejb3-proxy-spi.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/jbossts/lib/jbossjts-integration.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/hibernate/lib/hibernate-jbosscache2.jar" sourcepath="/thirdparty/hibernate/lib/hibernate-jbosscache2-sources.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/jboss/common-beans/lib/jboss-common-beans.jar"/>
 	<classpathentry kind="output" path="output/eclipse-classes"/>
 </classpath>
Index: testsuite/src/main/org/jboss/test/varia/property/PropertyEditorManagerServiceTestCase.java
===================================================================
--- testsuite/src/main/org/jboss/test/varia/property/PropertyEditorManagerServiceTestCase.java	(revision 112986)
+++ testsuite/src/main/org/jboss/test/varia/property/PropertyEditorManagerServiceTestCase.java	(working copy)
@@ -21,11 +21,11 @@
  */
 package org.jboss.test.varia.property;
 
-import java.beans.PropertyEditor;
-import java.beans.PropertyEditorManager;
 
 import java.util.Properties;
 
+import org.jboss.common.beans.property.ByteEditor;
+import org.jboss.common.beans.property.finder.PropertyEditorFinder;
 import org.jboss.test.JBossTestCase;
 import org.jboss.varia.property.PropertyEditorManagerService;
 
@@ -39,10 +39,10 @@
  */
 public class PropertyEditorManagerServiceTestCase extends JBossTestCase
 {
-
+ 
    PropertyEditorManagerService s = new PropertyEditorManagerService();
    Class bc = Byte.class;
-   Class be = org.jboss.util.propertyeditor.ByteEditor.class;
+   Class be = ByteEditor.class;
    Class sc = String.class;
    Class de = DummyEditor.class;
 
@@ -62,8 +62,8 @@
    protected void setUp()
    {
       getLog().debug("+++ " + getName());
-      PropertyEditorManager.registerEditor(bc, null);
-      PropertyEditorManager.registerEditor(sc, null);
+      PropertyEditorFinder.getInstance().register(bc, null);
+      PropertyEditorFinder.getInstance().register(sc, null);
    }
 
    /** 
@@ -78,7 +78,7 @@
       assertEquals(be, s.findEditor("java.lang.Byte").getClass());
       s.registerEditor(bc.getName(), be.getName());
 
-      String ed = "org.jboss.util.propertyeditor,org.example.editor";
+      String ed = "org.jboss.common.beans.property,org.example.editor";
       s.setEditorSearchPath(ed);
       assertEquals(ed, s.getEditorSearchPath());
 
@@ -102,7 +102,7 @@
       s.start();
       s.destroy();
       assertEquals(null, s.findEditor(tc));
-      assertEquals(null, PropertyEditorManager.findEditor(tc));
+      assertEquals(null, PropertyEditorFinder.getInstance().find(tc));
       assertEquals(0, s.getRegisteredEditors().length);
    }
 
Index: testsuite/src/main/org/jboss/test/jbossts/crash/AppServerJDBCXARecovery.java
===================================================================
--- testsuite/src/main/org/jboss/test/jbossts/crash/AppServerJDBCXARecovery.java	(revision 112986)
+++ testsuite/src/main/org/jboss/test/jbossts/crash/AppServerJDBCXARecovery.java	(working copy)
@@ -48,13 +48,13 @@
 import java.io.ByteArrayInputStream;
 import java.lang.reflect.Method;
 import java.beans.PropertyEditor;
-import java.beans.PropertyEditorManager;
 import java.security.NoSuchAlgorithmException;
 import java.security.InvalidKeyException;
 import java.math.BigInteger;
 
 import org.jboss.security.SecurityAssociation;
 import org.jboss.security.SimplePrincipal;
+import org.jboss.common.beans.property.finder.PropertyEditorFinder;
 import org.jboss.logging.Logger;
 
 /**
@@ -448,7 +448,7 @@
             }
 
             Method setter = clazz.getMethod("set" + name, new Class[] { type });
-            PropertyEditor editor = PropertyEditorManager.findEditor(type);
+            PropertyEditor editor = PropertyEditorFinder.getInstance().find(type);
             editor.setAsText(value);
             setter.invoke(xads, new Object[] { editor.getValue() });
         }
Index: testsuite/src/main/org/jboss/test/util/test/PropertyEditorsUnitTestCase.java
===================================================================
--- testsuite/src/main/org/jboss/test/util/test/PropertyEditorsUnitTestCase.java	(revision 112986)
+++ testsuite/src/main/org/jboss/test/util/test/PropertyEditorsUnitTestCase.java	(working copy)
@@ -22,7 +22,6 @@
 package org.jboss.test.util.test;
 
 import java.beans.PropertyEditor;
-import java.beans.PropertyEditorManager;
 import java.io.File;
 import java.net.InetAddress;
 import java.net.URL;
@@ -38,19 +37,22 @@
 import javax.management.ObjectName;
 
 import junit.framework.Test;
+import junit.framework.TestCase;
 import junit.framework.TestSuite;
 
+import org.jboss.common.beans.property.DateEditor;
+import org.jboss.common.beans.property.DocumentEditor;
+import org.jboss.common.beans.property.ElementEditor;
+import org.jboss.common.beans.property.finder.PropertyEditorFinder;
+import org.jboss.logging.Logger;
 import org.jboss.test.JBossTestCase;
-import org.jboss.util.propertyeditor.DateEditor;
-import org.jboss.util.propertyeditor.DocumentEditor;
-import org.jboss.util.propertyeditor.ElementEditor;
 import org.w3c.dom.Node;
 import org.w3c.dom.NodeList;
 
 /**
  * Unit tests for the custom JBoss property editors
  *
- * @see org.jboss.util.propertyeditor.PropertyEditors
+ * @see PropertyEditorFinder
  * 
  * @author Scott.Stark@jboss.org
  * @author Dimitris.Andreadis@jboss.org
@@ -58,19 +60,6 @@
  */
 public class PropertyEditorsUnitTestCase extends JBossTestCase
 {
-   Calendar calendar = Calendar.getInstance();
-   
-   /** Augment the PropertyEditorManager search path to incorporate the JBoss
-    specific editors. This simply references the PropertyEditors.class to
-    invoke its static initialization block.
-    */
-   static
-   {
-      // Class c = org.jboss.util.propertyeditor.PropertyEditors.class;
-      // JBAS-3617 - on linux the above initializer doesn't work! 
-      org.jboss.util.propertyeditor.PropertyEditors.init();
-   }
-
    static class StringArrayComparator implements Comparator
    {
       public int compare(Object o1, Object o2)
@@ -118,11 +107,12 @@
       // so it must be defined explicitly when running under some JVMs
       TestSuite suite = new TestSuite();
       suite.addTest(new PropertyEditorsUnitTestCase("testEditorSearchPath"));
-      suite.addTest(new PropertyEditorsUnitTestCase("testJavaLangEditors"));
-      suite.addTest(new PropertyEditorsUnitTestCase("testJBossEditors"));
       suite.addTest(new PropertyEditorsUnitTestCase("testDateEditor"));
       suite.addTest(new PropertyEditorsUnitTestCase("testDocumentElementEditors"));
 
+      addJavaLangEditors(suite);
+      addJBossEditors(suite);
+
       return suite;
    }
    
@@ -131,29 +121,36 @@
       super(name);
    }
 
+   private static void addTests(final TestSuite suite, final Class[] types, final String[][] inputData, final Object[][] expectedData, final String[][] expectedStringData, final Comparator[] comparators)
+   {
+      for (int t = 0; t < types.length; t++)
+      {
+         suite.addTest(new PropertyEditorTest(types[t], inputData[t], expectedData[t], expectedStringData[t], comparators[t]));
+      }
+   }
+
    public void testEditorSearchPath()
       throws Exception
    {
       getLog().debug("+++ testEditorSearchPath");
-      String[] searchPath = PropertyEditorManager.getEditorSearchPath();
+      String[] searchPath = PropertyEditorFinder.getInstance().getEditorSearchPackages();
       boolean foundJBossPath = false;
       for(int p = 0; p < searchPath.length; p ++)
       {
          String path = searchPath[p];
          getLog().debug("path["+p+"]="+path);
-         foundJBossPath |= path.equals("org.jboss.util.propertyeditor");
+         foundJBossPath |= path.equals("org.jboss.common.beans.property");
       }
-      assertTrue("Found org.jboss.util.propertyeditor in search path", foundJBossPath);
+      assertTrue("Found 'org.jboss.common.beans.property' in search path", foundJBossPath);
    }
 
    /** The mechanism for mapping java.lang.* variants of the primative types
     misses editors for java.lang.Boolean and java.lang.Integer. Here we test
     the java.lang.* variants we expect editors for.
     **/
-   public void testJavaLangEditors()
+   private static void addJavaLangEditors(final TestSuite suite)
       throws Exception
    {
-      getLog().debug("+++ testJavaLangEditors");
       // The supported java.lang.* types
       Class[] types = {
          Boolean.class,
@@ -192,7 +189,7 @@
       };
       // The expected string output from getAsText()
       String[][] expectedStringData = {
-         {"true", "false", "true", "false", "true", "false", "null"},
+         {"true", "false", "true", "false", "true", "false", null},
          {"1", "-1", "0", "26"},
          {"1", "-1", "0", "160"},
          {"1", "-1", "0", "160"},
@@ -200,22 +197,21 @@
          {"1.0", "-1.0", "0.0", "1000.1"},
          {"1.0", "-1.0", "0.0", "1000.1"},
          {"1", "-1", "0"},
-         {"A", "a", "Z", "z"},            
+         {"A", "a", "Z", "z"},
       };
       Comparator[] comparators = new Comparator[types.length];
 
-      doTests(types, inputData, expectedData, expectedStringData, comparators);
+      addTests(suite, types, inputData, expectedData, expectedStringData, comparators);
    }
 
    /** Test custom JBoss property editors.
     **/
-   public void testJBossEditors()
+   private static void addJBossEditors(final TestSuite suite)
       throws Exception
    {
-      getLog().debug("+++ testJBossEditors");
       Class[] types = {
          javax.management.ObjectName.class,
-         java.util.Properties.class,
+//         java.util.Properties.class,
          java.io.File.class,
          java.net.URL.class,
          java.lang.String.class,         
@@ -230,8 +226,8 @@
       String[][] inputData = {
          // javax.management.ObjectName.class
          {"jboss.test:test=1"},
-         // java.util.Properties.class
-         {"prop1=value1\nprop2=value2\nprop3=value3\nprop32=${prop3}\nprop4=${user.home}\nprop5=${some.win32.path}"},
+//         // java.util.Properties.class
+//         {"prop1=value1\nprop2=value2\nprop3=value3\nprop32=${prop3}\nprop4=${user.home}\nprop5=${some.win32.path}"},
          // java.io.File.class
          {"/tmp/test1", "/tmp/subdir/../test2"},
          // java.net.URL.class
@@ -251,6 +247,7 @@
          // Date.class
          {"Jan 4, 2005", "Tue Jan  4 23:38:21 PST 2005", "Tue, 04 Jan 2005 23:38:48 -0800"}
       };
+      final Calendar calendar = Calendar.getInstance();
       // The expected instance for each inputData value
       calendar.set(2005, 0, 4, 0, 0, 0);
       calendar.set(Calendar.MILLISECOND, 0);
@@ -260,17 +257,17 @@
       Date date2 = calendar.getTime();
       calendar.set(2005, 0, 4, 23, 38, 48);
       Date date3 = calendar.getTime();
-      Properties props = new Properties();
-      props.setProperty("prop1", "value1");
-      props.setProperty("prop2", "value2");
-      props.setProperty("prop3", "value3");
-      props.setProperty("prop32", "value3");
-      props.setProperty("prop4", System.getProperty("user.home"));
-      System.setProperty("some.win32.path", "C:\\disk1\\root\\");
-      props.setProperty("prop5", "C:\\disk1\\root\\");
+//      Properties props = new Properties();
+//      props.setProperty("prop1", "value1");
+//      props.setProperty("prop2", "value2");
+//      props.setProperty("prop3", "value3");
+//      props.setProperty("prop32", "value3");
+//      props.setProperty("prop4", System.getProperty("user.home"));
+//      System.setProperty("some.win32.path", "C:\\disk1\\root\\");
+//      props.setProperty("prop5", "C:\\disk1\\root\\");
       Object[][] expectedData = {
          {new ObjectName("jboss.test:test=1")},
-         {props},
+//         {props},
          {new File("/tmp/test1").getCanonicalFile(), new File("/tmp/test2").getCanonicalFile()},
          {new URL("http://www.jboss.org")},
          {new String("JBoss, Home of Professional Open Source")},
@@ -287,9 +284,9 @@
          // javax.management.ObjectName.class
          {"jboss.test:test=1"},
          // java.util.Properties.class
-         {"prop1=value1\nprop2=value2\nprop3=value3\nprop32=${prop3}\nprop4=${user.home}\nprop5=${some.win32.path}"},
+//         {"prop1=value1\nprop2=value2\nprop3=value3\nprop32=${prop3}\nprop4=${user.home}\nprop5=${some.win32.path}"},
          // java.io.File.class
-         {"/tmp/test1", "/tmp/subdir/../test2"},
+         {"/tmp/test1", "/tmp/test2"},
          // java.net.URL.class
          {"http://www.jboss.org"},
          // java.lang.String.class
@@ -299,7 +296,7 @@
          // InetAddress.class, localhost must be defined for this to work
          {"127.0.0.1", "localhost"},
          // String[].class
-         {"1,2,3", "a,b,c", "", "#,%,\\,,.,_$,,v"},
+         {"1,2,3", "a,b,c", "", "#,%,\\,,.,_$,\\,v"},
          // Class[].class
          {"java.lang.Integer,java.lang.Float"},
          // int[].class
@@ -310,7 +307,7 @@
       // The Comparator for non-trival types
       Comparator[] comparators = {
          null, // ObjectName
-         null, // Properties
+//         null, // Properties
          null, // File
          null, // URL
          null, // String
@@ -322,7 +319,7 @@
          null // Date
       };
 
-      doTests(types, inputData, expectedData, expectedStringData, comparators);
+      addTests(suite, types, inputData, expectedData, expectedStringData, comparators);
    }
    
    public void testDateEditor() throws Exception
@@ -418,7 +415,7 @@
       {
          Class type = types[t];
          getLog().debug("Checking property editor for: "+type);
-         PropertyEditor editor = PropertyEditorManager.findEditor(type);
+         PropertyEditor editor = PropertyEditorFinder.getInstance().find(type);
          assertTrue("Found property editor for: "+type, editor != null);
          getLog().debug("Found property editor for: "+type+", editor="+editor.getClass().getName());
          assertTrue("inputData.length == expectedData.length", inputData[t].length == expectedData[t].length);
@@ -442,12 +439,13 @@
                
             String expectedStringOutput = expectedStringData[t][i];
             String stringOutput = editor.getAsText();
+            getLog().debug("editor " + editor.getClass());
             getLog().debug("setAsText '" + logString(input) + "'");
             getLog().debug("getAsText '" + logString(stringOutput) + "'");
-               
+
             boolean stringOutputEquals = stringOutput != null ?
                   stringOutput.equals(expectedStringOutput) : expectedStringOutput == null;
-            assertTrue("PropertyEditor: " + editor.getClass().getName() + ", getAsText() == expectedStringOutput '" +
+            assertTrue("PropertyEditor: " + editor.getClass().getName() + ", getAsText() '" + logString(stringOutput) + "' == expectedStringOutput '" +
                   logString(expectedStringOutput) + "'", stringOutputEquals);           
          }
       }
@@ -470,4 +468,63 @@
    {
       return s != null ? s : "<null>";
    }
+
+   public static class PropertyEditorTest extends TestCase
+   {
+      private static final Logger log = Logger.getLogger(PropertyEditorTest.class);
+
+      private final Class<?> type;
+      private final String[] inputData;
+      private final Object[] expectedData;
+      private final String[] expectedStringData;
+      private final Comparator<Object> c;
+
+      private PropertyEditorTest(final Class<?> type, final String[] inputData, final Object[] expectedData, final String[] expectedStringData, final Comparator<Object> c)
+      {
+         super("testPropertyEditor " + type);
+         this.type = type;
+         this.inputData = inputData;
+         this.expectedData = expectedData;
+         this.expectedStringData = expectedStringData;
+         this.c = c;
+      }
+
+      @Override
+      protected void runTest()
+      {
+         log.debug("Checking property editor for: "+type);
+         PropertyEditor editor = PropertyEditorFinder.getInstance().find(type);
+         assertTrue("Found property editor for: "+type, editor != null);
+         log.debug("Found property editor for: "+type+", editor="+editor.getClass().getName());
+         assertTrue("inputData.length == expectedData.length", inputData.length == expectedData.length);
+         for(int i = 0; i < inputData.length; i ++)
+         {
+            String input = inputData[i];
+            editor.setAsText(input);
+            Object expected = expectedData[i];
+            Object output = editor.getValue();
+            boolean equals = false;
+            if (c == null)
+            {
+               equals = output != null ? output.equals(expected) : expected == null;
+            }
+            else
+            {
+               equals = c.compare(output, expected) == 0;
+            }
+            assertTrue("Transform of "+input+" equals "+expected+", output="+output, equals);
+
+            String expectedStringOutput = expectedStringData[i];
+            String stringOutput = editor.getAsText();
+            log.debug("editor " + editor.getClass());
+            log.debug("setAsText '" + logString(input) + "'");
+            log.debug("getAsText '" + logString(stringOutput) + "'");
+
+            boolean stringOutputEquals = stringOutput != null ?
+                    stringOutput.equals(expectedStringOutput) : expectedStringOutput == null;
+            assertTrue("PropertyEditor: " + editor.getClass().getName() + ", getAsText() '" + logString(stringOutput) + "' == expectedStringOutput '" +
+                    logString(expectedStringOutput) + "'", stringOutputEquals);
+         }
+      }
+   }
 }
